=== icons/CMakeLists.txt ===
ecm_install_icons(
ICONS
128-apps-labplot2.png
150-apps-labplot2.png
16-apps-labplot2.png
22-apps-labplot2.png
256-apps-labplot2.png
310-apps-labplot2.png
32-apps-labplot2.png
44-apps-labplot2.png
48-apps-labplot2.png
512-apps-labplot2.png
64-apps-labplot2.png
sc-apps-labplot2.svgz
DESTINATION ${ICON_INSTALL_DIR}/)
