=== tests/backend/CMakeLists.txt ===
add_subdirectory(Column)
add_subdirectory(Parser)
add_subdirectory(Range)
add_subdirectory(TextLabel)
add_subdirectory(XYCurve)
