=== tests/import_export/CMakeLists.txt ===
add_subdirectory(ASCII)
add_subdirectory(Binary)
add_subdirectory(JSON)
add_subdirectory(MQTT)
add_subdirectory(Project)
add_subdirectory(Spice)

IF (READSTAT_FOUND OR NOT WIN32)
	add_subdirectory(ReadStat)
ENDIF ()
IF (MATIO_FOUND)
	add_subdirectory(Matio)
ENDIF ()
IF (HDF5_FOUND)
	add_subdirectory(HDF5)
ENDIF ()

# add_subdirectory(DATASETS)
