=== debian/changelog ===
labplot (2.9.0-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Tue, 03 May 2022 08:22:01 +0200

labplot (2.9.0~beta-1) experimental; urgency=medium

  * New upstream development release.
  * Adapt watch file for beta/rc versions.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16.0
    - add libmarkdown2-dev, libmatio-dev, and libreadstat-dev, needed by new
      features built by default
  * Update lintian overrides.
  * Switch Vcs-* fields to the 'experimental' packaging branch.

 -- Pino Toscano <pino@debian.org>  Sat, 26 Mar 2022 22:03:26 +0100
