## labplot 2.10.0

=== debian/changelog ===
labplot (2.10.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Sun, 11 Jun 2023 21:33:45 +0200

labplot (2.10.0-1) experimental; urgency=medium

  * New upstream release.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update watch file for the new path.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.2, no changes needed.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.17.0
    - bump Qt packages to 5.10.0
    - bump extra-cmake-modules to 5.16.0
    - add qtbase5-private-dev, needed for the embedded copy of QXlsx
  * Pass -DENABLE_VECTOR_BLF=OFF to cmake to not build the Vector BLF file
    format support, as it requires libraries not currently available in Debian.

 -- Pino Toscano <pino@debian.org>  Wed, 22 Mar 2023 22:28:40 +0100
