=== debian/control ===
--- 
+++ 
@@ -4,14 +4,15 @@
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: debhelper-compat (= 13),
- cmake (>= 3.16.0~),
+ cmake (>= 3.17.0~),
  gettext,
  pkg-kde-tools (>= 0.15.16),
  pkg-config,
- qtbase5-dev (>= 5.6.0),
- libqt5svg5-dev,
- libqt5serialport5-dev,
- extra-cmake-modules (>= 1.3.0),
+ qtbase5-dev (>= 5.10.0~),
+ qtbase5-private-dev (>= 5.10.0~),
+ libqt5svg5-dev (>= 5.10.0~),
+ libqt5serialport5-dev (>= 5.10.0~),
+ extra-cmake-modules (>= 5.16.0~),
  libkf5archive-dev (>= 5.16.0),
  libkf5completion-dev (>= 5.16.0),
  libkf5config-dev (>= 5.16.0),
@@ -48,7 +49,7 @@
  xauth <!nocheck>,
  xvfb <!nocheck>,
  locales-all <!nocheck>,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/labplot
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/labplot.git
